#
# This script was written by Renaud Deraison <deraison@cvs.nessus.org>,
#
#
# See the Nessus Scripts License for details
#

if(description)
{
 script_id(11055);
 script_cve_id("CAN-2002-0656");
 script_version("$Revision: 1.3 $");
 
 name["english"] = "OpenSSL overflow";

 script_name(english:name["english"]]);
 
 desc["english"] = "
The remote host is using a version of OpenSSL which is
older than 0.9.6e or 0.9.7-beta3

This version is vulnerable to a buffer overflow which,
may allow an attacker to obtain a shell on this host.

*** Nessus solely relied on the banner of the remote host
*** to issue this warning


Solution : Upgrade to version 0.9.6e (0.9.7beta3) or newer
Risk factor : High";

 script_description(english:desc["english"], francais:desc["francais"]);
 
 summary["english"] = "Checks for version of OpenSSL";
 summary["francais"] = "Vrifie la version de OpenSSL";
 
 script_summary(english:summary["english"], francais:summary["francais"]);
 
 script_category(ACT_GATHER_INFO);
 
 
 script_copyright(english:"This script is Copyright (C) 2002 Renaud Deraison",
		francais:"Ce script est Copyright (C) 2002 Renaud Deraison");
 family["english"] = "Gain a shell remotely";
 family["francais"] = "Obtenir un shell  distance";
 script_family(english:family["english"], francais:family["francais"]);
 script_dependencie("find_service.nes");
 script_require_ports("Services/www", 80);
 exit(0);
}

#
# The script code starts here - we rely on Apache to spit OpenSSL's
# version. That suck.
#

port = get_kb_item("Services/www");
if(!port)port = 443;
if(get_port_state(port))
{
 key = string("www/banner/", port);
 banner = get_kb_item(key);
 if(!banner)
 {
   soc = open_sock_tcp(port);
   req = http_get(item:"/", port:port);
   send(socket:soc, data:req);
   banner = recv(socket:soc, length:2000);
   close(soc);
 }
 
 

 serv = strstr(banner, "Server");
 
 if(ereg(pattern:".*OpenSSL/0\.9\.([0-5][^0-9]|6[a-d]).*", string:serv))
 {
   security_hole(port);
   exit(0);
 }
 
 if(ereg(pattern:".*OpenSSL/0\.9\.7-beta[12]", string:serv))
 {
  security_hole(port);
  exit(0);
 }
}
